"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const HttpInternals_1 = require("./HttpInternals");
const Pipeline_1 = require("./Pipeline");
function Use(...middleware) {
    return (event, context, callback) => {
        const req = HttpInternals_1.Request(event);
        req.headers["apigateway.event"] = JSON.stringify(event);
        const res = HttpInternals_1.Response(req);
        req.context = context;
        req.res = res;
        // This is required to avoid multiple callback executions.
        let finished = false;
        res.on('finish', () => {
            if (finished) {
                return;
            }
            finished = true;
            callback(null, res.toJSON());
        });
        Pipeline_1.Pipeline(middleware).fault((context, error) => {
            callback(error);
        }).flow({ req, res });
    };
}
exports.Use = Use;
//# sourceMappingURL=HttpHelper.js.map