"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const pipeworks = require("pipeworks");
function Pipeline(middleware) {
    const pipe = pipeworks();
    lodash_1.reduce(middleware, (pipe, executor) => {
        return pipe.fit(
        // Pipeworks compatible definition
        (context, next) => {
            // We extract request and response from context
            executor(context.req, context.res, (err) => {
                // If error passed to next, throw it to trigger fault
                if (err) {
                    throw err;
                }
                else {
                    return next(context);
                }
            });
        });
    }, pipe);
    return pipe;
}
exports.Pipeline = Pipeline;
//# sourceMappingURL=Pipeline.js.map